Index: uspace/lib/c/generic/time.c
===================================================================
--- uspace/lib/c/generic/time.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/time.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -611,6 +611,6 @@
 			goto fallback;
 		
-		clock_conn = loc_service_connect(EXCHANGE_SERIALIZE,
-		    svc_id, IPC_FLAG_BLOCKING);
+		clock_conn = loc_service_connect(svc_id, INTERFACE_DDF,
+		    IPC_FLAG_BLOCKING);
 		if (!clock_conn)
 			goto fallback;
Index: uspace/lib/c/generic/vfs/vfs.c
===================================================================
--- uspace/lib/c/generic/vfs/vfs.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/vfs/vfs.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -75,5 +75,5 @@
 	
 	while (vfs_sess == NULL)
-		vfs_sess = service_connect_blocking(EXCHANGE_PARALLEL, SERVICE_VFS,
+		vfs_sess = service_connect_blocking(SERVICE_VFS, INTERFACE_VFS,
 		    0);
 	
@@ -796,5 +796,5 @@
 }
 
-async_sess_t *fd_session(exch_mgmt_t mgmt, int fildes)
+async_sess_t *fd_session(int fildes, iface_t iface)
 {
 	struct stat stat;
@@ -810,5 +810,5 @@
 	}
 	
-	return loc_service_connect(mgmt, stat.service, 0);
+	return loc_service_connect(stat.service, iface, 0);
 }
 
Index: uspace/lib/c/include/async.h
===================================================================
--- uspace/lib/c/include/async.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/include/async.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -59,8 +59,9 @@
  *
  * @param callid ID of incoming call or 0 if connection initiated from
- *               inside using async_connect_to_me()
+ *               inside using async_create_callback_port()
  * @param call   Incoming call or 0 if connection initiated from inside
- * @param arg    Local argument passed from async_new_connection() or
- *               async_connect_to_me()
+ *               using async_create_callback_port()
+ * @param arg    Local argument.
+ *
  */
 typedef void (*async_port_handler_t)(ipc_callid_t, ipc_call_t *, void *);
@@ -82,4 +83,12 @@
 	EXCHANGE_ATOMIC = 0,
 	
+	/** Exchange management via mutual exclusion
+	 *
+	 * Suitable for any kind of client/server communication,
+	 * but can limit parallelism.
+	 *
+	 */
+	EXCHANGE_SERIALIZE = 1,
+	
 	/** Exchange management via phone cloning
 	 *
@@ -89,13 +98,5 @@
 	 *
 	 */
-	EXCHANGE_PARALLEL = 1,
-	
-	/** Exchange management via mutual exclusion
-	 *
-	 * Suitable for any kind of client/server communication,
-	 * but can limit parallelism.
-	 *
-	 */
-	EXCHANGE_SERIALIZE = 2
+	EXCHANGE_PARALLEL = 2
 } exch_mgmt_t;
 
@@ -358,6 +359,5 @@
 extern async_sess_t *async_connect_kbox(task_id_t);
 
-extern int async_connect_to_me(async_exch_t *, sysarg_t, sysarg_t, sysarg_t,
-    async_port_handler_t, void *);
+extern int async_connect_to_me(async_exch_t *, sysarg_t, sysarg_t, sysarg_t);
 
 extern int async_hangup(async_sess_t *);
Index: uspace/lib/c/include/devman.h
===================================================================
--- uspace/lib/c/include/devman.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/include/devman.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -42,6 +42,6 @@
 #include <stdbool.h>
 
-extern async_exch_t *devman_exchange_begin_blocking(devman_interface_t);
-extern async_exch_t *devman_exchange_begin(devman_interface_t);
+extern async_exch_t *devman_exchange_begin_blocking(iface_t);
+extern async_exch_t *devman_exchange_begin(iface_t);
 extern void devman_exchange_end(async_exch_t *);
 
@@ -53,7 +53,6 @@
 extern int devman_drv_fun_offline(devman_handle_t);
 
-extern async_sess_t *devman_device_connect(exch_mgmt_t, devman_handle_t,
-    unsigned int);
-extern async_sess_t *devman_parent_device_connect(exch_mgmt_t, devman_handle_t,
+extern async_sess_t *devman_device_connect(devman_handle_t, unsigned int);
+extern async_sess_t *devman_parent_device_connect(devman_handle_t,
     unsigned int);
 
Index: uspace/lib/c/include/ipc/devman.h
===================================================================
--- uspace/lib/c/include/ipc/devman.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/include/ipc/devman.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -141,11 +141,4 @@
 
 typedef enum {
-	DEVMAN_DRIVER = 1,
-	DEVMAN_CLIENT,
-	DEVMAN_CONNECT_TO_DEVICE,
-	DEVMAN_CONNECT_TO_PARENTS_DEVICE
-} devman_interface_t;
-
-typedef enum {
 	DEVMAN_DRIVER_REGISTER = IPC_FIRST_USER_METHOD,
 	DEVMAN_ADD_FUNCTION,
Index: uspace/lib/c/include/ipc/inet.h
===================================================================
--- uspace/lib/c/include/ipc/inet.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/include/ipc/inet.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -37,16 +37,4 @@
 
 #include <ipc/common.h>
-
-/** Inet ports */
-typedef enum {
-	/** Default port */
-	INET_PORT_DEFAULT = 1,
-	/** Configuration port */
-	INET_PORT_CFG,
-	/** Ping service port */
-	INET_PORT_PING,
-	/** Ping6 service port */
-	INET_PORT_PING6
-} inet_port_t;
 
 /** Requests on Inet default port */
Index: uspace/lib/c/include/ipc/loc.h
===================================================================
--- uspace/lib/c/include/ipc/loc.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/include/ipc/loc.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -76,20 +76,4 @@
 } loc_event_t;
 
-/** Ports provided by location service.
- *
- * Every process that connects to loc must ask one of following
- * ports, otherwise connection will be refused.
- *
- */
-typedef enum {
-	/** Service supplier (server) port */
-	LOC_PORT_SUPPLIER = 1,
-	/** Service consumer (client) port */
-	LOC_PORT_CONSUMER,
-	/** Create new connection to instance of device that
-	    is specified by second argument of call. */
-	LOC_CONNECT_TO_SERVICE
-} loc_interface_t;
-
 typedef struct {
 	service_id_t id;
Index: uspace/lib/c/include/ipc/logger.h
===================================================================
--- uspace/lib/c/include/ipc/logger.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/include/ipc/logger.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -69,11 +69,4 @@
 } logger_writer_request_t;
 
-typedef enum {
-	/** Interface for controlling logger behavior. */
-	LOGGER_INTERFACE_CONTROL,
-	/** Interface for servers writing to the log. */
-	LOGGER_INTERFACE_WRITER
-} logger_interface_t;
-
 #endif
 
Index: uspace/lib/c/include/ipc/services.h
===================================================================
--- uspace/lib/c/include/ipc/services.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/include/ipc/services.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -52,14 +52,11 @@
 } service_t;
 
-#define SERVICE_NAME_CORECFG	"corecfg"
-#define SERVICE_NAME_DHCP       "net/dhcp"
-#define SERVICE_NAME_DNSR       "net/dnsr"
-#define SERVICE_NAME_INET       "net/inet"
-#define SERVICE_NAME_INETCFG    "net/inetcfg"
-#define SERVICE_NAME_INETPING   "net/inetping"
-#define SERVICE_NAME_INETPING6  "net/inetping6"
-#define SERVICE_NAME_NETCONF    "net/netconf"
-#define SERVICE_NAME_UDP	"net/udp"
-#define SERVICE_NAME_TCP	"net/tcp"
+#define SERVICE_NAME_CORECFG  "corecfg"
+#define SERVICE_NAME_DHCP     "net/dhcp"
+#define SERVICE_NAME_DNSR     "net/dnsr"
+#define SERVICE_NAME_INET     "net/inet"
+#define SERVICE_NAME_NETCONF  "net/netconf"
+#define SERVICE_NAME_UDP      "net/udp"
+#define SERVICE_NAME_TCP      "net/tcp"
 
 #endif
Index: uspace/lib/c/include/loc.h
===================================================================
--- uspace/lib/c/include/loc.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/include/loc.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -42,12 +42,10 @@
 typedef void (*loc_cat_change_cb_t)(void);
 
-extern async_exch_t *loc_exchange_begin_blocking(loc_interface_t);
-extern async_exch_t *loc_exchange_begin(loc_interface_t);
+extern async_exch_t *loc_exchange_begin_blocking(iface_t);
+extern async_exch_t *loc_exchange_begin(iface_t);
 extern void loc_exchange_end(async_exch_t *);
 
 extern int loc_server_register(const char *);
 extern int loc_service_register(const char *, service_id_t *);
-extern int loc_service_register_with_iface(const char *, service_id_t *,
-    sysarg_t);
 extern int loc_service_unregister(service_id_t);
 extern int loc_service_add_to_cat(service_id_t, category_id_t);
@@ -65,7 +63,5 @@
 extern loc_object_type_t loc_id_probe(service_id_t);
 
-extern async_sess_t *loc_service_connect_iface(service_id_t, iface_t,
-    unsigned int);
-extern async_sess_t *loc_service_connect(exch_mgmt_t, service_id_t,
+extern async_sess_t *loc_service_connect(service_id_t, iface_t,
     unsigned int);
 
Index: uspace/lib/c/include/ns.h
===================================================================
--- uspace/lib/c/include/ns.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/include/ns.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -42,14 +42,6 @@
 
 extern int service_register(service_t);
-extern async_sess_t *service_connect(exch_mgmt_t, service_t, sysarg_t);
-extern async_sess_t *service_connect_iface_extended(service_t, iface_t, sysarg_t);
-extern async_sess_t *service_connect_iface(exch_mgmt_t, sysarg_t, service_t, sysarg_t);
-extern async_sess_t *service_connect_blocking(exch_mgmt_t, service_t, sysarg_t);
-extern async_sess_t *service_connect_blocking_iface_extended(service_t, iface_t,
-    sysarg_t);
-extern async_sess_t *service_connect_blocking_iface(exch_mgmt_t, sysarg_t, service_t,
-    sysarg_t);
-extern async_sess_t *service_bind(service_t, sysarg_t, sysarg_t, sysarg_t,
-    async_port_handler_t);
+extern async_sess_t *service_connect(service_t, iface_t, sysarg_t);
+extern async_sess_t *service_connect_blocking(service_t, iface_t, sysarg_t);
 
 extern int ns_ping(void);
Index: uspace/lib/c/include/vfs/vfs_sess.h
===================================================================
--- uspace/lib/c/include/vfs/vfs_sess.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/include/vfs/vfs_sess.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -39,6 +39,6 @@
 #include <stdio.h>
 
-extern async_sess_t *fd_session(exch_mgmt_t, int);
-extern async_sess_t *fsession(exch_mgmt_t, FILE *);
+extern async_sess_t *fd_session(int, iface_t);
+extern async_sess_t *fsession(FILE *, iface_t);
 
 #endif
Index: uspace/lib/drv/generic/driver.c
===================================================================
--- uspace/lib/drv/generic/driver.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/drv/generic/driver.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -53,6 +53,4 @@
 #include <devman.h>
 
-#include <ipc/driver.h>
-
 #include "dev_iface.h"
 #include "ddf/driver.h"
@@ -130,5 +128,10 @@
 	
 	char *dev_name = NULL;
-	async_data_write_accept((void **) &dev_name, true, 0, 0, 0, 0);
+	int rc = async_data_write_accept((void **) &dev_name, true, 0, 0, 0, 0);
+	if (rc != EOK) {
+		async_answer_0(iid, rc);
+		return;
+	}
+	
 	dev->name = dev_name;
 	
@@ -278,5 +281,6 @@
 }
 
-static void driver_connection_devman(ipc_callid_t iid, ipc_call_t *icall)
+static void driver_connection_devman(ipc_callid_t iid, ipc_call_t *icall,
+    void *arg)
 {
 	/* Accept connection */
@@ -436,45 +440,14 @@
 }
 
-static void driver_connection_driver(ipc_callid_t iid, ipc_call_t *icall)
+static void driver_connection_driver(ipc_callid_t iid, ipc_call_t *icall,
+    void *arg)
 {
 	driver_connection_gen(iid, icall, true);
 }
 
-static void driver_connection_client(ipc_callid_t iid, ipc_call_t *icall)
+static void driver_connection_client(ipc_callid_t iid, ipc_call_t *icall,
+    void *arg)
 {
 	driver_connection_gen(iid, icall, false);
-}
-
-/** Function for handling connections to device driver. */
-static void driver_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg)
-{
-	sysarg_t conn_type;
-
-	if (iid == 0) {
-		/* Callback connection from devman */
-		/* XXX Use separate handler for this type of connection */
-		conn_type = DRIVER_DEVMAN;
-	} else {
-		conn_type = IPC_GET_ARG1(*icall);
-	}
-
-	/* Select interface */
-	switch (conn_type) {
-	case DRIVER_DEVMAN:
-		/* Handle request from device manager */
-		driver_connection_devman(iid, icall);
-		break;
-	case DRIVER_DRIVER:
-		/* Handle request from drivers of child devices */
-		driver_connection_driver(iid, icall);
-		break;
-	case DRIVER_CLIENT:
-		/* Handle request from client applications */
-		driver_connection_client(iid, icall);
-		break;
-	default:
-		/* No such interface */
-		async_answer_0(iid, ENOENT);
-	}
 }
 
@@ -620,12 +593,13 @@
  * The session will be automatically closed when @a dev is destroyed.
  *
- * @param dev	Device
- * @param mgmt	Exchange management style
- * @return	New session or NULL if session could not be created
- */
-async_sess_t *ddf_dev_parent_sess_create(ddf_dev_t *dev, exch_mgmt_t mgmt)
+ * @param dev Device
+ *
+ * @return New session or NULL if session could not be created
+ *
+ */
+async_sess_t *ddf_dev_parent_sess_create(ddf_dev_t *dev)
 {
 	assert(dev->parent_sess == NULL);
-	dev->parent_sess = devman_parent_device_connect(mgmt, dev->handle,
+	dev->parent_sess = devman_parent_device_connect(dev->handle,
 	    IPC_FLAG_BLOCKING);
 
@@ -955,6 +929,18 @@
 	 * incoming connections.
 	 */
-	async_set_fallback_port_handler(driver_connection, NULL);
-	int rc = devman_driver_register(driver->name);
+	port_id_t port;
+	int rc = async_create_port(INTERFACE_DDF_DRIVER, driver_connection_driver,
+	    NULL, &port);
+	if (rc != EOK)
+		return rc;
+	
+	rc = async_create_port(INTERFACE_DDF_DEVMAN, driver_connection_devman,
+	    NULL, &port);
+	if (rc != EOK)
+		return rc;
+	
+	async_set_fallback_port_handler(driver_connection_client, NULL);
+	
+	rc = devman_driver_register(driver->name);
 	if (rc != EOK) {
 		printf("Error: Failed to register driver with device manager "
Index: uspace/lib/drv/generic/remote_ahci.c
===================================================================
--- uspace/lib/drv/generic/remote_ahci.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/drv/generic/remote_ahci.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -72,6 +72,5 @@
 	
 	if ((devn_size > 5) && (str_lcmp(devn, "ahci_", 5) == 0)) {
-		async_sess_t *sess = devman_device_connect(EXCHANGE_PARALLEL,
-		    funh, IPC_FLAG_BLOCKING);
+		async_sess_t *sess = devman_device_connect(funh, IPC_FLAG_BLOCKING);
 		
 		if (sess) {
Index: uspace/lib/drv/generic/remote_audio_pcm.c
===================================================================
--- uspace/lib/drv/generic/remote_audio_pcm.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/drv/generic/remote_audio_pcm.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -146,6 +146,5 @@
 	if (ret != EOK)
 		return NULL;
-	return devman_device_connect(EXCHANGE_SERIALIZE, device_handle,
-	    IPC_FLAG_BLOCKING);
+	return devman_device_connect(device_handle, IPC_FLAG_BLOCKING);
 }
 
@@ -158,5 +157,5 @@
 audio_pcm_sess_t *audio_pcm_open_service(service_id_t id)
 {
-	return loc_service_connect(EXCHANGE_SERIALIZE, id, IPC_FLAG_BLOCKING);
+	return loc_service_connect(id, INTERFACE_DDF, IPC_FLAG_BLOCKING);
 }
 
@@ -322,9 +321,13 @@
 
 	async_exch_t *exch = async_exchange_begin(sess);
+	
 	int ret = async_req_1_0(exch, DEV_IFACE_ID(AUDIO_PCM_BUFFER_IFACE),
 	    IPC_M_AUDIO_PCM_REGISTER_EVENTS);
 	if (ret == EOK) {
-		ret = async_connect_to_me(exch, 0, 0, 0, event_callback, arg);
-	}
+		port_id_t port;
+		ret = async_create_callback_port(exch, INTERFACE_AUDIO_PCM_CB, 0, 0,
+		    event_callback, arg, &port);
+	}
+	
 	async_exchange_end(exch);
 	return ret;
Index: uspace/lib/drv/generic/remote_nic.c
===================================================================
--- uspace/lib/drv/generic/remote_nic.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/drv/generic/remote_nic.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -137,5 +137,7 @@
 	    NIC_CALLBACK_CREATE, &answer);
 	
-	rc = async_connect_to_me(exch, 0, 0, 0, cfun, carg);
+	port_id_t port;
+	rc = async_create_callback_port(exch, INTERFACE_NIC_CB, 0, 0,
+	    cfun, carg, &port);
 	if (rc != EOK) {
 		async_forget(req);
Index: uspace/lib/drv/include/ddf/driver.h
===================================================================
--- uspace/lib/drv/include/ddf/driver.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/drv/include/ddf/driver.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -117,5 +117,5 @@
 extern devman_handle_t ddf_dev_get_handle(ddf_dev_t *);
 extern const char *ddf_dev_get_name(ddf_dev_t *);
-extern async_sess_t *ddf_dev_parent_sess_create(ddf_dev_t *, exch_mgmt_t);
+extern async_sess_t *ddf_dev_parent_sess_create(ddf_dev_t *);
 extern async_sess_t *ddf_dev_parent_sess_get(ddf_dev_t *);
 extern ddf_fun_t *ddf_fun_create(ddf_dev_t *, fun_type_t, const char *);
Index: uspace/lib/fs/libfs.c
===================================================================
--- uspace/lib/fs/libfs.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/fs/libfs.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -342,5 +342,7 @@
 	 * Ask VFS for callback connection.
 	 */
-	async_connect_to_me(exch, 0, 0, 0, vfs_connection, NULL);
+	port_id_t port;
+	rc = async_create_callback_port(exch, INTERFACE_VFS_DRIVER_CB, 0, 0,
+	    vfs_connection, NULL, &port);
 	
 	/*
Index: uspace/lib/graph/graph.c
===================================================================
--- uspace/lib/graph/graph.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/graph/graph.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -606,6 +606,6 @@
 {
 	/* Find the visualizer or renderer with the given service ID. */
-	visualizer_t *vs = graph_get_visualizer(IPC_GET_ARG1(*icall));
-	renderer_t *rnd = graph_get_renderer(IPC_GET_ARG1(*icall));
+	visualizer_t *vs = graph_get_visualizer(IPC_GET_ARG2(*icall));
+	renderer_t *rnd = graph_get_renderer(IPC_GET_ARG2(*icall));
 	
 	if (vs != NULL)
Index: uspace/lib/gui/terminal.c
===================================================================
--- uspace/lib/gui/terminal.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/gui/terminal.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -679,5 +679,5 @@
 	
 	list_foreach(terms, link, terminal_t, cur) {
-		if (cur->dsid == (service_id_t) IPC_GET_ARG1(*icall)) {
+		if (cur->dsid == (service_id_t) IPC_GET_ARG2(*icall)) {
 			term = cur;
 			break;
Index: uspace/lib/gui/window.c
===================================================================
--- uspace/lib/gui/window.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/gui/window.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -623,6 +623,6 @@
 	}
 	
-	async_sess_t *reg_sess = loc_service_connect(EXCHANGE_SERIALIZE,
-	    reg_dsid, 0);
+	async_sess_t *reg_sess =
+	    loc_service_connect(reg_dsid, INTERFACE_COMPOSITOR, 0);
 	if (reg_sess == NULL) {
 		free(win);
@@ -639,5 +639,5 @@
 	}
 	
-	win->osess = loc_service_connect(EXCHANGE_SERIALIZE, out_dsid, 0);
+	win->osess = loc_service_connect(out_dsid, INTERFACE_COMPOSITOR, 0);
 	if (win->osess == NULL) {
 		free(win);
@@ -645,5 +645,5 @@
 	}
 	
-	win->isess = loc_service_connect(EXCHANGE_SERIALIZE, in_dsid, 0);
+	win->isess = loc_service_connect(in_dsid, INTERFACE_COMPOSITOR, 0);
 	if (win->isess == NULL) {
 		async_hangup(win->osess);
Index: uspace/lib/hound/src/protocol.c
===================================================================
--- uspace/lib/hound/src/protocol.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/hound/src/protocol.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -97,5 +97,5 @@
 	if (ret != EOK)
 		return NULL;
-	return loc_service_connect(EXCHANGE_PARALLEL, id, IPC_FLAG_BLOCKING);
+	return loc_service_connect(id, INTERFACE_HOUND, IPC_FLAG_BLOCKING);
 }
 
Index: uspace/lib/nic/src/nic_driver.c
===================================================================
--- uspace/lib/nic/src/nic_driver.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/nic/src/nic_driver.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -249,5 +249,5 @@
 	
 	/* Connect to the parent's driver. */
-	parent_sess = ddf_dev_parent_sess_create(dev, EXCHANGE_SERIALIZE);
+	parent_sess = ddf_dev_parent_sess_create(dev);
 	if (parent_sess == NULL)
 		return EPARTY;
Index: uspace/lib/usb/src/dev.c
===================================================================
--- uspace/lib/usb/src/dev.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/usb/src/dev.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -50,6 +50,5 @@
 {
 	async_sess_t *parent_sess =
-	    devman_parent_device_connect(EXCHANGE_ATOMIC, device_handle,
-	        IPC_FLAG_BLOCKING);
+	    devman_parent_device_connect(device_handle, IPC_FLAG_BLOCKING);
 	if (!parent_sess)
 		return ENOMEM;
Index: uspace/lib/usb/src/hc.c
===================================================================
--- uspace/lib/usb/src/hc.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/usb/src/hc.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -51,6 +51,5 @@
 		assert(connection->hc_sess == NULL);
 		/* Parallel exchange for us */
-		connection->hc_sess = devman_device_connect(EXCHANGE_PARALLEL,
-		        connection->hc_handle, 0);
+		connection->hc_sess = devman_device_connect(connection->hc_handle, 0);
 		if (!connection->hc_sess) {
 			fibril_mutex_unlock(&connection->guard);
Index: uspace/lib/usbvirt/src/device.c
===================================================================
--- uspace/lib/usbvirt/src/device.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/usbvirt/src/device.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -93,5 +93,5 @@
 	
 	async_sess_t *hcd_sess =
-	    devman_device_connect(EXCHANGE_SERIALIZE, handle, 0);
+	    devman_device_connect(handle, 0);
 	if (!hcd_sess)
 		return ENOMEM;
@@ -101,5 +101,9 @@
 	
 	async_exch_t *exch = async_exchange_begin(hcd_sess);
-	rc = async_connect_to_me(exch, 0, 0, 0, callback_connection, NULL);
+	
+	port_id_t port;
+	rc = async_create_callback_port(exch, INTERFACE_USBVIRT_CB, 0, 0,
+	    callback_connection, NULL, &port);
+	
 	async_exchange_end(exch);
 	
Index: uspace/srv/bd/part/guid_part/guid_part.c
===================================================================
--- uspace/srv/bd/part/guid_part/guid_part.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/srv/bd/part/guid_part/guid_part.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -339,7 +339,7 @@
 
 	/* Get the device handle. */
-	dh = IPC_GET_ARG1(*icall);
-
-	/* 
+	dh = IPC_GET_ARG2(*icall);
+
+	/*
 	 * Determine which partition device is the client connecting to.
 	 * A linear search is not terribly fast, but we only do this
Index: uspace/srv/bd/part/mbr_part/mbr_part.c
===================================================================
--- uspace/srv/bd/part/mbr_part/mbr_part.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/srv/bd/part/mbr_part/mbr_part.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -416,7 +416,7 @@
 
 	/* Get the device handle. */
-	dh = IPC_GET_ARG1(*icall);
-
-	/* 
+	dh = IPC_GET_ARG2(*icall);
+
+	/*
 	 * Determine which partition device is the client connecting to.
 	 * A linear search is not terribly fast, but we only do this
Index: uspace/srv/bd/sata_bd/sata_bd.c
===================================================================
--- uspace/srv/bd/sata_bd/sata_bd.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/srv/bd/sata_bd/sata_bd.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -172,5 +172,5 @@
 
 	/* Get the device service ID. */
-	dsid = IPC_GET_ARG1(*icall);
+	dsid = IPC_GET_ARG2(*icall);
 
 	/* Determine which disk device is the client connecting to. */
Index: uspace/srv/devman/client_conn.c
===================================================================
--- uspace/srv/devman/client_conn.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/srv/devman/client_conn.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -726,5 +726,5 @@
 
 /** Function for handling connections from a client to the device manager. */
-void devman_connection_client(ipc_callid_t iid, ipc_call_t *icall)
+void devman_connection_client(ipc_callid_t iid, ipc_call_t *icall, void *arg)
 {
 	/* Accept connection. */
Index: uspace/srv/devman/client_conn.h
===================================================================
--- uspace/srv/devman/client_conn.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/srv/devman/client_conn.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -36,5 +36,5 @@
 #include "devman.h"
 
-extern void devman_connection_client(ipc_callid_t, ipc_call_t *);
+extern void devman_connection_client(ipc_callid_t, ipc_call_t *, void *);
 
 #endif
Index: uspace/srv/devman/driver.c
===================================================================
--- uspace/srv/devman/driver.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/srv/devman/driver.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -36,5 +36,4 @@
 #include <sys/stat.h>
 #include <io/log.h>
-#include <ipc/driver.h>
 #include <loc.h>
 #include <str_error.h>
@@ -573,11 +572,11 @@
 	
 	if (rc != EOK) {
-		/* TODO handle error */
-	}
-
-	/* Wait for answer from the driver. */
-	async_wait_for(req, &rc);
-
-	switch(rc) {
+		async_forget(req);
+	} else {
+		/* Wait for answer from the driver. */
+		async_wait_for(req, &rc);
+	}
+
+	switch (rc) {
 	case EOK:
 		dev->state = DEVICE_USABLE;
@@ -592,6 +591,4 @@
 	
 	dev->passed_to_driver = true;
-
-	return;
 }
 
Index: uspace/srv/devman/drv_conn.c
===================================================================
--- uspace/srv/devman/drv_conn.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/srv/devman/drv_conn.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -49,5 +49,4 @@
 #include <io/log.h>
 #include <ipc/devman.h>
-#include <ipc/driver.h>
 #include <loc.h>
 
@@ -131,5 +130,5 @@
 	}
 	/* FIXME: Work around problem with callback sessions */
-	async_sess_args_set(driver->sess, DRIVER_DEVMAN, 0, 0);
+	async_sess_args_set(driver->sess, INTERFACE_DDF_DEVMAN, 0, 0);
 	
 	log_msg(LOG_DEFAULT, LVL_NOTE,
@@ -587,5 +586,5 @@
 
 /** Function for handling connections from a driver to the device manager. */
-void devman_connection_driver(ipc_callid_t iid, ipc_call_t *icall)
+void devman_connection_driver(ipc_callid_t iid, ipc_call_t *icall, void *arg)
 {
 	client_t *client;
Index: uspace/srv/devman/drv_conn.h
===================================================================
--- uspace/srv/devman/drv_conn.h	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/srv/devman/drv_conn.h	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -37,5 +37,5 @@
 #include "devman.h"
 
-extern void devman_connection_driver(ipc_callid_t, ipc_call_t *);
+extern void devman_connection_driver(ipc_callid_t, ipc_call_t *, void *);
 
 #endif
Index: uspace/srv/devman/loc.c
===================================================================
--- uspace/srv/devman/loc.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/srv/devman/loc.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -59,6 +59,5 @@
 	}
 	
-	loc_service_register_with_iface(loc_pathname,
-	    &fun->service_id, INTERFACE_DDF_CLIENT);
+	loc_service_register(loc_pathname, &fun->service_id);
 	
 	tree_add_loc_function(tree, fun);
